#!/usr/bin/perl

# v1 (c) Jose MANS 7 Mai 1997.
#
# Ce programme est librement diffusable. Seul
# la vente de ce programme a besoin de l'accords de son auteur.
# L'auteur apprecirait qu'on lui face part des modifications
# apporte au programme.
#
# Email : mans@gyptis.linux.eu.org


$CONFIG		= "/var/lib/uucp/taylor_config";
$EXE		= "/usr/lib/uucp/";
$HOSTNAME	= `uname -n`;
$SPOOL		= "/var/spool";
$SYSTEM		= "system";
$FTP		= "/home/ftp/";
$INCOMING	= "/home/ftp/incoming";
$i		= 1;

sub modem_supplement()
{
$CHAT		= "\"\" ATZ OK ATDT\\T CONNECT";
$TYPE		= "modem";
$DIALER		= "${PORT}_DIALER";
$TIME		= "any";
$commands		= "rmail rnews rsmtp";
$protocol1		= "g";
$packetsize		= "1024";
$protocol_param		= "protocol-parameter ${protocol1} packet-size ${packetsize}";
}

sub hdb()
{
   printf"Voulez-vous une configuration HDB ou Taylor (h/T) ? :";
   $choix = <STDIN>;
   chop($choix);
   $choix =~ tr/A-Z/a-z/;

   if ($choix eq "h")
   {
      system("su uucp -c $EXE/uuconv -i taylor -o hdb");
   }
}

sub save_config()
{
   if ($APPEND)
   {
       open (OUT_CONFIG, ">>" . "$CONFIG/config");
   } else
   {
       open (OUT_CONFIG, ">" . "$CONFIG/config");
   }
   printf OUT_CONFIG "
hostname			$HOSTNAME

unknown send-request		true
unknown max-remote-debug	none
unknown remote-send		$FTP
unknown remote-receive		$INCOMING
unknown commands		rmail rnews rsmtp
";
   close(OUT_CONFIG);
}

sub save()
{
   printf"

ATTENTION: Cette version va remplacer vos anciens fichiers
de configurations d'UUCP. Avant d'enregitrer les nouvelles
donnes voulez-vous les sauvegarder ? (O/n) : ";

   $choix = <STDIN>;
   chop($choix); # chop($var = <>); :-)
   $choix =~ tr/A-Z/a-z/;
   if ($choix eq "o" || $choix eq "")
   {
      system"cp -a $CONFIG $CONFIG.OLD";
      printf"Sauvegarede OK\n\n";
   }

   &modem_supplement();
   &prepare();
   &save_sys();
   &save_port();
   &save_dialer();
   &save_config();
   system"chmod 750 $CONFIG/config";
   system"chmod 750 $CONFIG/sys";
   system"chmod 750 $CONFIG/port";
   system"chmod 750 $CONFIG/dial";
   system"chmod -s $EXE/uuchk";  # For security
   system"chmod -s $EXE/uuconv"; # For security
}

sub debug()
{
   $system	= "Gyptis";
   $PHONE	= "04 91 60 43 61";
   $LOGIN	= "Uucptest";
   $passwd	= "test";
   $PORT	= "Courrier";
   $DEVICE	= "cua1";
   $speed	= "115200";
}

sub prepare()
{
   system("mkdir -p $CONFIG");
}

sub save_sys()
{
   if ($APPEND)
   {
       open (OUT_SYS, ">>" . "$CONFIG/sys");
   } else
   {
       open (OUT_SYS, ">" . "$CONFIG/sys");
   }
   printf OUT_SYS "system		%s\n", $system;
   printf OUT_SYS "myname	%s", $HOSTNAME;
   printf OUT_SYS "time		%s\n", $TIME;
   printf OUT_SYS "phone		%s\n", $PHONE;
   printf OUT_SYS "chat		\"\" \\r\\r ogin: %s assword: %s\n", $LOGIN, $passwd;
   printf OUT_SYS "port		%s\n", $PORT;
   printf OUT_SYS "speed		%s\n", $speed;
   printf OUT_SYS "commands	%s\n", $commands;
   printf OUT_SYS "%s\n", $protocol_param;

   close(OUT_SYS);
}

sub view_sys()
{
printf "system		%s\n", $system;
printf "myname		%s", $HOSTNAME;
printf "time		%s\n", $TIME;
printf "phone		%s\n", $PHONE;
printf "chat		\"\" \\r\\r ogin: %s assword: %s\n", $LOGIN, $passwd;
printf "port		%s\n", $PORT;
printf "speed		%s\n", $speed;
printf "commands	%s\n", $commands;
printf "%s\n", $protocol_param;
}

sub save_port()
{
   if ($APPEND)
   {
       open (OUT_PORT, ">>" . "$CONFIG/port");
   } else
   {
       open (OUT_PORT, ">" . "$CONFIG/port");
   }
   printf OUT_PORT "port		%s\n", $PORT;
   printf OUT_PORT "type		%s\n", $TYPE;
   printf OUT_PORT "device		/dev/%s\n", $DEVICE;
   printf OUT_PORT "speed		%s\n", $speed;
   printf OUT_PORT "dialer		%s\n", $DIALER;

   close(OUT_PORT);
}

sub view_port()
{
printf "\nFICHIER port\n";
printf "port		%s\n", $PORT;
printf "type		%s\n", $TYPE;
printf "device		/dev/%s", $DEVICE;
printf "speed		%s\n", $speed;
printf "dialer		%s\n", $DIALER;
}

sub save_dialer()
{
   if ($APPEND)
   {
       open (OUT_DIALER, ">>" . "$CONFIG/dial");
   } else
   {
       open (OUT_DIALER, ">" . "$CONFIG/dial");
   }
   printf OUT_DIALER "\ndialer		%s\n", $DIALER;
   printf OUT_DIALER "chat		%s\n\n", $CHAT;
   printf OUT_DIALER "\n";

   close(OUT_DIALER);
}

sub view_dialer()
{
printf "\nFichier Dialer\n";
printf "dialer		%s\n", $DIALER;
printf "chat		%s\n", $CHAT;
}

sub add_host()
{
RETj: while()
   {
      printf"$CLS";
      &host();
      &system("$system");
      if ($trouve)
      {
         $trouve = 0;
         printf"

  ATTENTION: Ce nom de machine est deja utilise,
  vous devez en choisir un autre afin d'eviter
  toute confusion.

";
# Voulez-vous le remplacer ?
      next RETj;
      }
   last RETj;
   }
}

sub host()
{
   RETb: while ()
   {
    printf"
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

Quelle est le nom de la machine que vous desirez appeller ? : ";
       $system = <STDIN>;
       chop($system);
       if ($system eq "")
       {
          $erreur++;
          printf"
   ATTENTION vous devez saisir le nom de la machine
   appellante ou appellee imperativement!

";
          next RETb;
       }
       last RETb;
   }
}

#printf"
#Allez-vous  joindre cette machine par
#le reseau telephonique ou au contraire 
#passer par un provider, acces TCP/IP ou PPP ? : ";

sub tel()
{
RETc: while ()
   {
      printf"A t-elle un numero de telephonne, si oui lequel ? : ";
      $PHONE = <STDIN>;
      chop($PHONE);
      if ($PHONE eq "")
      {
         printf"
   ATTENTION: Aucuns numero de telephonne est pris en compte.
   Cela signifie, si vous souhaitez appeller cette machine,
   utiliser le reso PPP, ou tout autre TCP/IP.

";
         next RETc;
      }
      last RETc;
   }
}


sub login()
{
   RETe: while()
   {
      printf"
Saississez le nom d'dentification que vous possedez sur 
cette machine (login) : ";

      $LOGIN = <STDIN>;
      chop($LOGIN);
      if ($LOGIN eq "")
      {
         $erreur++;
         printf"
   ATTENTION vous devez saisir le login que vous possedez
   sur cette machine ($SYSTEM}!
   Sinon vous ne pourrez jamais l'appeller!

";
      next RETe;
      }
      last RETe;
   }
}
       
sub passwd()
{
RETf: while()
   {
      printf"Son mot de pass : ";
      $passwd = <STDIN>;
      chop($passwd);

      printf"Verification : ";
      $passwdverif = <STDIN>;
      chop($passwdverif);

      # Pas la penne de verifie si la variable $passwd contient un
      # mot de pass. Car le systeme peut tres bien ne pas en
      # demander.

      if ($passwd eq $passwdverif)
      {
         last RETf;
      }

      $erreur++;
      printf"ATTENTION Votre mot de pass ne correspond pas aux deux
saisis demandes.
Veuillez recommencer en faisant attention aux majuscules, municules.

";
    }
}

# Config Modem

sub name_modem()
{
RETh: while()
   {
      printf"Quel est le nom de votre modem ? : ";
      $PORT = <STDIN>;
      chop($PORT);

      if ($PORT eq "")
      {
         $erreur++;
         printf"
ATTENTION: Vous devez imperativement nommer votre modem
Meme en metant un nom qui ne correspond au votre. Ex :

  nom du modem : musclor  :-)


";
         next RETh;
      }
      last RETh
    }
}

sub device()
{
RETg: while()
   {
      printf"
Quel est le port serie que vous utilisez ? (cuaN, ttySN...) : ";

      $DEVICE = <STDIN>;
      chop($DEVICE);

      if ($DEVICE eq "")
      {
         if ($erreur => 4)
         {
            printf"Alle on va encore une fois ce repeter!!";
         }
         printf"
  ATTENTION: Vous devez repondre a cette question afin
  de permetre a UUCP d'utiliser le bon port! Ex:

    Si votre modem et sur le port serie No 2, la chaine
    a saisir sera \"cua1\". Si port No 1, chaine=\"cua0\".

      Autre exemple :
 
      Si vous etes aussi un utilisateur Windows/DOS et que
      votre modem est sur le port COM2, alors il faudra
      repondre \"cua1\".
               ";
         next RETg;
      }
      last RETg;
   }
}

sub vitesse()
{
RETi: while()
   {

      printf"$CLS

Quel est la vitesse de votre modem ?

1.    300 bps (Outch!)
2.   1200 bps
3.   2400 bps
4.   9600 bps
5.  14400 bps V32bis
6.  19200 bps V32Terbo
7.  28800 bps V34
8.  33600 bps V34+
9.   4800 bps
10. 56000 bps (X2, Rockwell)
11. 64000 bps (Numeris).

Votre choix ? : ";

  chop($vitesse = <STDIN> );
  if ($vitesse <=0 || $vitesse >=12)
  {
     printf"
Votre choix '%s' n'est pas bon.
A mon avis vous devriez enlever vos gands
de box pour taper sur le clavier!!
", $vitesse;
     if ($erreur >=4)
     {
        printf "ta pas d'amis ou quoi ? regarde ton ecran bon sang!!";
     }
     die" nia";
  }

  if ($vitesse <= 3)
  {
     $speed = 2400;
  }
   else #1
   {
     if ($vitesse == 4)
     {
        $speed = 9600;
     }
      else #2
      {
        if ($vitesse <= 6)
        {
           $speed = 19200;
        }
        else #3
        {
           if ($vitesse == 7)
           {
              $speed = 38400;
           }
           else #4
           {
             if ($vitesse == 8 )
             {
                $speed = 115200;
             }
              else #5
              {
                 if ($vitesse ==9)
                 {
                    $speed = 4800;
                 }
                 else #6
                 {
                    $speed = 115200;
                 }
              } #5
           } #4
        } #3
     } #2
   } #1
   last RETi;

   } #While
} #sub

#fonction pair du programme.

sub view_system()
{
   for ($n=0; $n!=$i ; $n++)
   {
      printf "%s", $host[$n];
   }
}

sub system()
{
  local($cherche) = @_;

  open (SYS, "$CONFIG/sys") || die "error cfile sys!, $CONFIG/sys introuvable...";;

RETa: while (<SYS>) #1
  {
     tr/A-Z/a-z/;
     if (/$SYSTEM/) #2
     { 
        $_ =~ s/${SYSTEM}//;
        $_ =~ s/ //g;
        $_ =~ s/\t//g;

        if (/^$cherche\b/i) #3
        {
           $trouve = 1;
           $host[$i] = $_;
           $i++;
           while (<SYS>) #4
           {
              if (/$SYSTEM/) #5
              {
                 last RETa;
              } #5
              $host[$i] = $_;
              $i++;
           } #4
        } #3
     } #2
  } #1
}

sub nsystem
{
  open (SYS, "$CONFIG/sys");
  while (<SYS>)
  {
     if (/$SYSTEM/)
     { 
        $nsystem++;
     }
  }
  close(SYS);
}

sub cherch()
{
#$cherche = "ham";
#$imp = &cherch();
#print $imp;
  open (SYS, "$CONFIG/sys");
  while (<SYS>)
  {
     if (/$cherche/)
     { 
        return($_);
     }
  }
}

1;
